import { ComponentFixture, TestBed } from '@angular/core/testing';
import { HttpHeaders, HttpResponse } from '@angular/common/http';
import { HttpClientTestingModule } from '@angular/common/http/testing';
import { of } from 'rxjs';

import { WatchListEntryService } from '../service/watch-list-entry.service';

import { WatchListEntryComponent } from './watch-list-entry.component';

describe('WatchListEntry Management Component', () => {
  let comp: WatchListEntryComponent;
  let fixture: ComponentFixture<WatchListEntryComponent>;
  let service: WatchListEntryService;

  beforeEach(() => {
    TestBed.configureTestingModule({
      imports: [HttpClientTestingModule],
      declarations: [WatchListEntryComponent],
    })
      .overrideTemplate(WatchListEntryComponent, '')
      .compileComponents();

    fixture = TestBed.createComponent(WatchListEntryComponent);
    comp = fixture.componentInstance;
    service = TestBed.inject(WatchListEntryService);

    const headers = new HttpHeaders();
    jest.spyOn(service, 'query').mockReturnValue(
      of(
        new HttpResponse({
          body: [{ id: 123 }],
          headers,
        })
      )
    );
  });

  it('Should call load all on init', () => {
    // WHEN
    comp.ngOnInit();

    // THEN
    expect(service.query).toHaveBeenCalled();
    expect(comp.watchListEntries?.[0]).toEqual(expect.objectContaining({ id: 123 }));
  });
});
